const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const team_memberships = sequelize.define(
    'team_memberships',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

role: {
        type: DataTypes.ENUM,
      
      

        values: [

"owner",


"admin",


"editor",


"viewer",


"finance_manager"

        ],

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"invited",


"active",


"revoked"

        ],

      },

invited_at: {
        type: DataTypes.DATE,
      
      

      },

accepted_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  team_memberships.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity












































//end loop



    db.team_memberships.belongsTo(db.teams, {
      as: 'team',
      foreignKey: {
        name: 'teamId',
      },
      constraints: false,
    });

    db.team_memberships.belongsTo(db.users, {
      as: 'member_user',
      foreignKey: {
        name: 'member_userId',
      },
      constraints: false,
    });

    db.team_memberships.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.team_memberships.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.team_memberships.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return team_memberships;
};


